#ifndef _MIDIS_H
#define _MIDIS_H
#include <iostream.h>

//its really much more fun if you unlock the songs by youself,
//so, if you want my game to be funny, dont cheat.
//if you want my game to be boring and short, go on, change the variables
//but you have been warned.


struct struct_midi
{
 	   int unlocked;
 	   MIDI *music;
 	   char name[7];
 	   char from_game[2][13];
 	   int unlock_price;
}midi[15];
 	   

int actual_midi;    //this is the next midi
int previous_midi;  //this is the midi thats actually playing
int playing_midi=1;
int allow_change_midi=1;

void init_midis()
{
    strcpy(midi[0].name, "midi0");
    strcpy(midi[1].name, "midi1");
    strcpy(midi[2].name, "midi2");
    strcpy(midi[3].name, "midi3");
    strcpy(midi[4].name, "midi4");
    strcpy(midi[5].name, "midi5");
    strcpy(midi[6].name, "midi6");
    strcpy(midi[7].name, "midi7");
    strcpy(midi[8].name, "midi8");
    strcpy(midi[9].name, "midi9");
    strcpy(midi[10].name, "midi10");
    strcpy(midi[11].name, "midi11");
    strcpy(midi[12].name, "midi12");
    strcpy(midi[13].name, "midi13");
    strcpy(midi[14].name, "midi14");

    strcpy(midi[0].from_game[0], "Adventure");
    strcpy(midi[0].from_game[1], "Island 3");
    strcpy(midi[1].from_game[0], "Castlevania");
    strcpy(midi[1].from_game[1], "");
    strcpy(midi[2].from_game[0], "City");
    strcpy(midi[2].from_game[1], "Connection");
    strcpy(midi[3].from_game[0], "Ghosts n'");
    strcpy(midi[3].from_game[1], "Goblins");
    strcpy(midi[4].from_game[0], "Golden");
    strcpy(midi[4].from_game[1], "Axe");
    strcpy(midi[5].from_game[0], "Sonic the");
    strcpy(midi[5].from_game[1], "Hedgehog");
    strcpy(midi[6].from_game[0], "Space");
    strcpy(midi[6].from_game[1], "Harrier");
    strcpy(midi[7].from_game[0], "Mappy");
    strcpy(midi[7].from_game[1], "");
    strcpy(midi[8].from_game[0], "Shadow");
    strcpy(midi[8].from_game[1], "Dancer");
    strcpy(midi[9].from_game[0], "Outrun");
    strcpy(midi[9].from_game[1], "");
    strcpy(midi[10].from_game[0], "Super");
    strcpy(midi[10].from_game[1], "Mario Bros.");
    strcpy(midi[11].from_game[0], "Super");
    strcpy(midi[11].from_game[1], "Hang-On");
    strcpy(midi[12].from_game[0], "Captain");
    strcpy(midi[12].from_game[1], "Tsubasa2");
    strcpy(midi[13].from_game[0], "Monkey");
    strcpy(midi[13].from_game[1], "Island");
    strcpy(midi[14].from_game[0], "Tetris");
    strcpy(midi[14].from_game[1], "");


    midi[0].unlocked=1;
    midi[1].unlocked=1;
    midi[2].unlocked=0;
    midi[3].unlocked=0;
    midi[4].unlocked=0;
    midi[5].unlocked=0;
    midi[6].unlocked=0;
    midi[7].unlocked=0;
    midi[8].unlocked=0;
    midi[9].unlocked=0;
    midi[10].unlocked=0;
    midi[11].unlocked=0;
    midi[12].unlocked=0;
    midi[13].unlocked=0;
    midi[14].unlocked=0;
    
    
    midi[2].unlock_price=6000;
    midi[3].unlock_price=6500;
    midi[4].unlock_price=7000;
    midi[5].unlock_price=7500;
    midi[6].unlock_price=8000;
    midi[7].unlock_price=9000;
    midi[8].unlock_price=10000;
    midi[9].unlock_price=11000;
    midi[10].unlock_price=12500;
    midi[11].unlock_price=14000;
    midi[12].unlock_price=16000;
    midi[13].unlock_price=18000;
    midi[14].unlock_price=20000;
    
    for(int i=0;i!=15;i++)
    {
        midi[i].music=(MIDI *)data[MIDI01+i].dat;
	}
}


void check_unlocked_midis()
{
     for(int i=0;i!=15;i++)
     {
 	     midi[i].unlocked=get_config_int("midis_please_dont_cheat",midi[i].name,midi[i].unlocked);
	 }
} 	 


void save_unlocked_midis()
{
    for(int i=0;i!=15;i++)
    {
	    set_config_int("midis_please_dont_cheat", midi[i].name, midi[i].unlocked);
	}
}

int search_next_midi(int actual)
{
 	while(actual!=15)
 	{
	    if(midi[actual+1].unlocked==1)
	    {
            actual++;
		    break;
		}
		else
		{
		 	actual++;
		}
	}
	if(actual==15)
	{
	   actual=0;
    }
    return actual; 
}




void process_midi()
{
	 
 	 if(playing_midi==1)
 	 {
          if(midi_pos<0 || key[KEY_SPACE])
          {
			  if(allow_change_midi==1)
			  {
			      stop_midi();
			  	  play_midi(midi[actual_midi].music,NULL);
			  	  previous_midi=actual_midi;
                  actual_midi=search_next_midi(actual_midi);
                  allow_change_midi=0;
			  }
		  }
  	 }
	 else
	 {
	  	 if(midi_pos>=0)
	  	 {
 			stop_midi();
		 }
	 }
	 if(!key[KEY_SPACE])
	 {
         allow_change_midi=1;
	 }
}

	 	 
#endif


