#include "init.h"
#include "spaceship.h"
#include "data.h"
#include "stars.h"
#include "enemies.h"
#include "collisions.h"
#include "midis.h"
#include "menu.h"
#include "timer.h"


void main_logic();
void main_draw();
void game();
void gameover();

int lives=3;                    //no cheating please(this game 
                                //is designed to be fun with
                                //3 lives, not 999).
             
int cash=0;                     //the same applies here,
              
int actual_score=0;             //here

int allowed_shop=1;

int better_shot_price=2000;     //and here

int done=0;

int main()
{
 	init();
 	init_midis();
 	
 	set_config_file("save.sps");
 	score = get_config_int("data_please_dont_cheat", "score", score);
 	check_unlocked_midis();
 	game();
 	set_config_int("data_please_dont_cheat", "score", score);
	save_unlocked_midis();
 	deinit();
 	return 0;

}
END_OF_MAIN();

void gameover()
{
 	 clear(buffer);
 	 remove_int(update_counter);
	 set_config_int("data_please_dont_cheat", "score", score);
 	 save_unlocked_midis();
 	 clear_keybuf();
     while(!key[KEY_ESC])
     {
	  					 
     textprintf(buffer,font,0,0,makecol(255,255,255),
	 "You have lost all the lives, but you have earned %d points.",actual_score);
     textprintf(buffer,font,0,15,makecol(255,255,255),
	 "so you now have a total of %d points.",score);
	 
	 
     if(key[KEY_ENTER])
     {
         done=1;
         break;
	 }
     draw_sprite(screen,buffer,0,0);
	 }

while(key[KEY_ENTER]){}
} 	 
 	 
 	 
void game()
{
 	done=0; 
	int option=0;
	lives=3;
	actual_score=0;
	cash=0;
	better_shot_price=2000;
do
{
 	option=menu();
 	if(option==1)
 	{
    	 unlock_menu();
	}
}
while(option==1);

 	if (option==0)
 	{
   	spaceship.bmp=(BITMAP*)data[SPACESHIP2].dat;
 	spaceship.next_shot=0;
 	spaceship.allowed_shot=1;
 	spaceship.state=ACTIVE;
 	spaceship.x=320;
 	spaceship.y=400;
 	spaceship.damage=1;
 	
 	for(int i=0;i!=10;i++)
 	{
		enemy[i].state=DEAD;
		enemy[i].level=0;

		for(int j=0;j!=3;j++)
		{
		    enemy[i].shot[j].bmp=(BITMAP *)data[ENEMY_SHOT].dat;
		    enemy[i].shot[j].state=INACTIVE;
		}
	}
	
	
 	for(int i=0;i!=25;i++)
 	{
		star[i].color=255;
		star[i].speed=4;
		star[i].y=rand() % 400;
		star[i].x=rand() % 500;
    }
 	for(int i=25;i!=50;i++)
 	{
		star[i].color=225;
		star[i].speed=6;
		star[i].y=rand() % 400;
		star[i].x=rand() % 500;
    }
 	for(int i=50;i!=75;i++)
 	{
		star[i].color=195;
		star[i].speed=8;
		star[i].y=rand() % 400;
		star[i].x=rand() % 500;
    }
 	for(int i=75;i!=100;i++)
 	{
		star[i].color=165;
		star[i].speed=10;
		star[i].y=rand() % 400;
		star[i].x=rand() % 500;
    }


 	for(int i=0;i!=20;i++)
 	{
		spaceship.shot[i].state=INACTIVE;
	}
	
	LOCK_VARIABLE(counter);
	LOCK_FUNCTION(update_counter);
	install_int_ex(update_counter, BPS_TO_TIMER(50));

	
 	while(done==0)
 	{
		if(key[KEY_ESC])
		{
		    done=1;
		    again=1;
		}
		while(counter)
		{
		    main_logic();
		    counter--;
		}
		main_draw();
	}
			
    }

	set_config_int("data_please_dont_cheat", "score", score);
	save_unlocked_midis();
	stop_midi();
	if(again==1)
	{
	    game();
	}
}




void main_logic()
{
 	     
 	     process_midi();
 	     
 	     if(key[KEY_ENTER])
 	     {
             midi_pause();
             remove_int(update_counter);
             clear(screen);
             draw_sprite(screen,(BITMAP *)data[PAUSE].dat,95,84);
             while(key[KEY_ENTER]) {}
             clear_keybuf();
             while(!key[KEY_ENTER]) {}
             clear_keybuf();
             while(key[KEY_ENTER]) {}
             clear_keybuf();
             
             clear(buffer);
             clear(screen);
             midi_resume();
             install_int_ex(update_counter, BPS_TO_TIMER(50));
		 }
		 
         if(lives==0)
         {
             gameover();
		 }
         
    	 if(!key[KEY_LCONTROL])
    	 {
             spaceship.allowed_shot=1;
	     }		
	     
	     if(actual_score>=8000 && actual_score<26000)
	     {
		     for(int i=0;i!=10;i++)
		     {
		  		 enemy[i].level=1;
			 }
         }   
         if(actual_score>=15000)
         {
		     for(int i=0;i!=10;i++)
		     {
		  		 enemy[i].level=2;
			 }
		 }
		     
        for(int i=0;i!=20;i++)
        {
		   	spaceship.shot[i].logic();
		}
		
		for(int i=0;i!=10;i++)
		{
		 		
		 	if(enemy[i].state==ALIVE)
			{
				for(int j=0;j!=20;j++)
				{

	 		        if(spaceship.shot[j].state==ACTIVE)
	 		        {
	 		        
		               if(collision(enemy[i].x,enemy[i].y,   //check the collisions
					   enemy[i].x+ENEMY_X,enemy[i].y+ENEMY_Y,
					   spaceship.shot[j].x,spaceship.shot[j].y,
					   spaceship.shot[j].x+8,spaceship.shot[j].y+8))
					   {
					   	   enemy[i].hp--;										
				           if(enemy[i].hp<=0)
				           {
    				           enemy[i].state=DEAD;
					           cash+=60+(enemy[i].level*150);
					           score+=60+(enemy[i].level*150);
					           actual_score+=60+(enemy[i].level*150);
						   }
						   
					       spaceship.shot[j].state=INACTIVE;

					   }
				    }	   
			     }
			 }
			
			enemy[i].logic();

		    

		    for(int k=0;k!=3;k++)
		    {
				if(enemy[i].shot[k].state==ACTIVE)
				{
			 		enemy[i].shot[k].logic();
			 		if(collision(spaceship.x,spaceship.y,
					 spaceship.x+42,spaceship.y+42,
					 enemy[i].shot[k].x,enemy[i].shot[k].y,
					 enemy[i].shot[k].x+4,enemy[i].shot[k].y+12))
					{
					    for(int a=0;a!=10;a++)
						{
			              enemy[a].state=DEAD;
			              spaceship.shot[a].state=INACTIVE;
			              spaceship.shot[a+10].state=INACTIVE;

                          for(int b=0;b!=3;b++)
                          {
	   		                 enemy[a].shot[b].state=INACTIVE;
						  }
						}
						spaceship.x=250;
						spaceship.y=400;
					    lives--;
					}
    		    }
			}
		}
		
		for(int i=0;i!=100;i++)
		{
		 	star[i].logic();	

		}
		
    	if(!key[KEY_LCONTROL])
    	{
           spaceship.allowed_shot=1;
	    }		
	     
       if(spaceship.state==ACTIVE)
       {
    	    for(int j=0; j!=10;j++)
		    {
			 	if(enemy[j].state==ALIVE)
				{	
	 	            if(collision(spaceship.x,spaceship.y,
    				 spaceship.x+42,spaceship.y+42,
	    			 enemy[j].x,enemy[j].y,
		    		 enemy[j].x+ENEMY_X, enemy[j].y+ENEMY_Y))
			    	{
			            lives--;
			            for(int a=0;a!=10;a++)
						{
			              enemy[a].state=DEAD;
			              spaceship.shot[a].state=INACTIVE;
			              spaceship.shot[a+10].state=INACTIVE;

                          for(int b=0;b!=3;b++)
                          {
	   		                 enemy[a].shot[b].state=INACTIVE;
						  }
						}
						
			            spaceship.x=250;
			            spaceship.y=400;
                    }
				}   
            }
        }
        
		spaceship.logic();
		
      
        if(key[KEY_F12])
		{
            save_bmp("screen.bmp",buffer,NULL);
        }
        
        if(key[KEY_F1])
		{
            if(cash>=2000 && allowed_shop==1)
            {
	            lives++;
	            cash-=2000;
	            allowed_shop=0;
	            play_sample((SAMPLE *)data[VIDA].dat,255,127,1000,FALSE);
			}
		}
		
        if(key[KEY_F2])
		{
            if(cash>=better_shot_price && allowed_shop==1)
            {
                play_sample((SAMPLE*)data[POWERUP].dat,255,127,1000,FALSE);
	            spaceship.damage++;
	            cash-=better_shot_price;
	            better_shot_price+=2000;
	            allowed_shop=0;
	            for(int i=0;i!=10;i++)
	            {
				 	if(enemy[i].state==ALIVE)
				 	{
    	                enemy[i].hp=((4+(enemy[i].level*3))-spaceship.damage);
					}
				}
			}
		}
		
		if(!(key[KEY_F1]) && !(key[KEY_F2]))
		{
             allowed_shop=1;
		}
		
		
    	if(!key[KEY_LCONTROL])
    	{
            spaceship.allowed_shot=1;
	    }	 
}



void main_draw()
{
    	clear(buffer);
		
		for(int i=0;i!=20;i++)
		{

		 	if(spaceship.damage<=6)
		 	{
		 	    spaceship.shot[i].draw(buffer,(BITMAP *)data[SHOT1+(spaceship.damage-1)].dat);
			}
			else
			{
			 	spaceship.shot[i].draw(buffer,(BITMAP *)data[SHOT1+5].dat);
			}
		}
		
		for(int i=0;i!=10;i++)
		{
		    enemy[i].draw(buffer);
		    for(int k=0;k!=3;k++)
		    {
				if(enemy[i].shot[k].state==ACTIVE)
				{ 
			 		enemy[i].shot[k].draw(buffer);
				}
		    }			        		
         }
		
		for(int i=0;i!=100;i++)
		{		
		    star[i].draw(buffer);
		}		
		
		spaceship.draw(buffer);
		
        draw_sprite(buffer,(BITMAP *)data[TROLL2].dat,535,15);
        textprintf(buffer,font,530,65,makecol(255,255,255),"Harry the");
        textprintf(buffer,font,530,85,makecol(255,255,255),"Troll's Shop");

        
        textprintf(buffer,font,530,125,makecol(255,255,255),"Buy a life");
        textprintf(buffer,font,530,145,makecol(255,255,255),"[F1] - $2000");
        
        textprintf(buffer,font,530,165,makecol(255,255,255),"Better Shot");
        textprintf(buffer,font,530,185,makecol(255,255,255),"[F2] - $%d",better_shot_price);
        
        
        textprintf(buffer,font,540,265,makecol(255,255,255),"Lives: %d",lives);
        textprintf(buffer,font,540,285,makecol(255,255,255),"Cash: %d", cash);
        textprintf(buffer,font,540,305,makecol(255,255,255),"Score: %d",actual_score);
        textprintf(buffer,font,540,325,makecol(255,255,255),"Shot lv.: %d",spaceship.damage);

        textprintf(buffer,font,540,400,makecol(255,255,255),"Now Playing:");

        textprintf_centre(buffer,font,590,420,makecol(255,255,255),"%s",midi[previous_midi].from_game[0]);
        textprintf_centre(buffer,font,590,440,makecol(255,255,255),"%s",midi[previous_midi].from_game[1]);
				
		draw_sprite(screen,buffer,0,0);	
}
 	 
